#!/bin/csh
# online spectrum creation script (eurogam format, SUN implementation)
# create spectra on disk
# $1=setup-directory-path
# $2=setup-directory-name
# $3=setupstyle (old/new)
# $4=spectrum path
setenv TRACE 0
set sortpath = $1
if($sortpath/$2 == "") then
echo Sort directory not specified
exit(8)
endif
if(-w $sortpath/$2) then
else
echo You do not have write permission for $sortpath/$2
exit(8)
endif
if(-d $sortpath/$2) then
else
echo $sortpath/$2 is not a sort setup directory
exit(8)
endif
set matrixdir = $4
if (! -e $matrixdir)  then
   mkdir $matrixdir
endif
if (! -d $matrixdir) then
   echo "$matrixdir is not a directory ... cannot create spectra"
   exit(8)
endif
set soap_port = $5    
set sstatus=0
#echo 'Creating spectra...'
pushd $sortpath/$2 > /dev/null
if ($3 == 'new') then
   MTspecmake < specinfo -d$matrixdir -newsetup
   set sstatus=$status
   echo MTspecmake disc spectra returned $sstatus
   if($sstatus) then
     exit($sstatus)
   endif
   rehash
#   sleep 5
   shm-specmake -new $matrixdir $soap_port < specinfo
   set sstatus=$status
   echo shm-specmake shm   spectra returned $sstatus
   if($sstatus) then
     exit($sstatus)
   endif
   rehash
else
   MTspecmake < specinfo -d$matrixdir
   set sstatus=$status
   echo MTspecmake disc spectra returned $sstatus
   rehash
   shm-specmake $matrixdir $soap_port < specinfo
   set sstatus=$status
   echo shm-specmake shm   spectra returned $sstatus
   rehash
endif
if($sstatus) then
   echo Sort setup error creating spectra
   popd > /dev/null
   exit(8)
endif
exit($sstatus)
