
set p [package require SOAP]
puts "SOAP version $p"

variable uri "urn:mtsort"

proc soap-init {} {
    global soap_port uri proxy
    variable proxy "http://localhost:[set soap_port]/"
    SOAP::create mtsortcommand -proxy $proxy -uri $uri -params {command string}
}

proc soap-connect {} {
    global soap_port
    soap-init
}
proc soap_connect {} {soap-connect}

set mtsortdebug 0
proc mtsort {base command message timeout} {
    global debug mtsortdebug
    if {$debug} then {puts stderr "mtsortcommand with argument \{$command\}" }
    upvar [set message] m

    set m ""
    set z [catch {set s [mtsortcommand $command]} m ]
    if {$debug} {puts "mtsortsoap: sent $command returned z $z m $m"}
    if {$z == ""} {set z 0}
    if {!$z} {
	if {[string range $m 0 1] == "OK"} {
	    set m [string range $m 3 end]
	    return 0
	} {
	    return -1
	}
    } {
	soap-error $m
	return -1
    }
}

proc soap-error {m} {
    if {[string range $m 0 19] == "SOAP transport error"} {set-footer "SOAP transport error"}
    if {[string range $m 0 8] == "SOAP-ENV:"} {set-footer "[string range $m 9 end]"}
}
