#########################################################################
#									#
#	MIDAS General sort package					#
#									#
#	File:		sosc.tcl (sort setup command config)		#
#									#
#	Author(s):	Janet Sampson/John Cresswell			#
#									#
#	Last revision:	26/2/97						#
#									#
#########################################################################

set frame SOSC
set frametitle "Sort Setup Command Config"
set icontitle "CommandConfig"

set debug 0
set started 0
set sync 0

set basedir ""
set sortdir ""
set runfilename ""

set currentcommand ""
set tracelevel 0


#------------------------------------------------------------------------------

proc last p {
   set n [llength $p]
   incr n -1
   return [lindex $p $n]
   }

proc front p {
   set n [llength $p]
   incr n -1
   return [lreplace $p $n $n]
   }

proc confirm {m action} {
   global debug
   set i [tk_dialog [self frame-name].quitdialog "[self frame-title] Confirmation" $m  "warning" 1 "Cancel" "Confirm"]
   if {$i} then $action
   if {$debug} then {puts stderr "confirm: $m choice $i"}
   }


proc click-sort-setup-frame {} {
   clear-footer
   inform sos {start "" ""}
   }

proc click-help {} {
    inform help html_show {"" $env(MIDASBASE)/MTsort/manual/setupconfig.html}
   }

# Requires htmlviewer.patch.tcl  to work ...
proc click-help {} {
    global env
    inform htmlviewer startfile $env(MTSORTBASE)/manual/setupconfig.html
   }

proc read-runfile {} {
   global debug
   if {$debug} {puts stderr "read-runfile..."}
   send sos call-back sosc sosc.read-runfile-continue get-sortdir
   }

proc sosc.read-runfile-continue f {
   global debug
   global sortdir basedir
   if {$debug}  then {puts stderr "[self frame-name]: call-back result $f"}

   set sortdir $f
   set basedir $sortdir
   }

proc load-handler-source {} {
   global debug currentcommand

   set hs ""

    if {$currentcommand == "Sym4d"} {set hs sos-Sym4dConfig}

   if {$hs == ""} return

   if {$debug} {puts stderr "Loading source for $hs ..."}
   catch {destroy .sosc}
   loadsource $hs
   set started 0
   start-handler
   set started 1
}

proc click-refresh {} {
   frame-busy
   clear-footer
   read-runinfo
   paint-runfiles
   repaint
   frame-idle
   }

proc start {command} {
    global started debug currentcommand

    if {$started} {
	if {$command == $currentcommand} {
	    click-refresh
	    bring-to-front [self frame-name]
            return
	}
    }
    read-runfile
    set currentcommand $command
    load-handler-source

}
